#define PWMa 27
uint8_t dispSetting = 0;
int state = 0;


const int freq = 15000;
const int resolution = 8;
const int pwmChannela = 0;

#include <Adafruit_ADS1X15.h>
Adafruit_ADS1115 ads;  /* Use this for the 16-bit version */
//Adafruit_ADS1015 ads;     /* Use this for the 12-bit version */

 
void setup(void)
{
  Serial.begin(115200);

  if (!ads.begin())
  {
    Serial.println("Failed to initialize ADS.");
    while (1);
  }

  Serial.println("Getting single-ended readings from AIN0..3");
  Serial.println("ADC Range: +/- 6.144V (1 bit = 3mV/ADS1015, 0.1875mV/ADS1115)");
  
  ledcSetup(pwmChannela, freq, resolution);
  /* Attach the LED PWM Channel to the GPIO Pin */
  ledcAttachPin(PWMa, pwmChannela);
  ledcWrite(pwmChannela, 0);
      for(int i = 0; i<255; i++){
      delay(30);
      ledcWrite(pwmChannela, i);
    }



}
 
void loop(void)
{
  delay (1000);
  ledcWrite(pwmChannela, 127);

      int16_t adc0, adc1, adc2, adc3;
      float volts0, volts1, volts2, volts3;
      
      adc0 = ads.readADC_SingleEnded(0);
      adc1 = ads.readADC_SingleEnded(1);
      adc2 = ads.readADC_SingleEnded(2);
      adc3 = ads.readADC_SingleEnded(3);
    
      volts0 = ads.computeVolts(adc0);
      volts1 = ads.computeVolts(adc1);
      volts2 = ads.computeVolts(adc2);
      volts3 = ads.computeVolts(adc3);
    
      Serial.println("-----------------------------------------------------------");
      Serial.print("AIN0: "); Serial.print(adc0); Serial.print("  "); Serial.print(volts0); Serial.println("V");
      Serial.print("AIN1: "); Serial.print(adc1); Serial.print("  "); Serial.print(volts1); Serial.println("V");
      Serial.print("AIN2: "); Serial.print(adc2); Serial.print("  "); Serial.print(volts2); Serial.println("V");
      Serial.print("AIN3: "); Serial.print(adc3); Serial.print("  "); Serial.print(volts3); Serial.println("V");



}