#include <Adafruit_ADS1X15.h>
Adafruit_ADS1115 ads;  /* Use this for the 16-bit version */
//const float gain = 0.0001875; //MVPB
const float gain = 0.000125
 
void setup(void)
{
  Serial.begin(115200);
 
  Serial.println("Getting single-ended readings from AIN0..3");
  Serial.println("ADC Range: +/- 6.144V (1 bit = 3mV/ADS1015, 0.1875mV/ADS1115)");
 
  // The ADC input range (or gain) can be changed via the following
  // functions, but be careful never to exceed VDD +0.3V max, or to
  // exceed the upper and lower limits if you adjust the input range!
  // Setting these values incorrectly may destroy your ADC!
  //                                                                ADS1015  ADS1115
  //                                                                -------  -------
  // ads.setGain(GAIN_TWOTHIRDS);  // 2/3x gain +/- 6.144V  1 bit = 3mV      0.1875mV (default)
  // ads.setGain(GAIN_ONE);        // 1x gain   +/- 4.096V  1 bit = 2mV      0.125mV
  //ads.setGain(GAIN_TWO);        // 2x gain   +/- 2.048V  1 bit = 1mV      0.0625mV
  // ads.setGain(GAIN_FOUR);       // 4x gain   +/- 1.024V  1 bit = 0.5mV    0.03125mV
  // ads.setGain(GAIN_EIGHT);      // 8x gain   +/- 0.512V  1 bit = 0.25mV   0.015625mV
  // ads.setGain(GAIN_SIXTEEN);    // 16x gain  +/- 0.256V  1 bit = 0.125mV  0.0078125mV

  // 3.3V Supply = 17574 bits
  

  if (!ads.begin())
  {
    Serial.println("Failed to initialize ADS.");
    while (1);
  }
  ads.setGain(GAIN_ONE);

}
 
void loop(void)
{

  int clockSpeed = millis(); 
  int stopTime = clockSpeed + 1001; 
  int poll = 0;

  for(clockSpeed = millis(); clockSpeed < stopTime; clockSpeed = millis() ){
      int16_t adc0, adc1, adc2, adc3;
      float volts0, volts1, volts2, volts3;
      
    
      adc0 = ads.readADC_SingleEnded(0);
      adc1 = ads.readADC_SingleEnded(1);
      adc2 = ads.readADC_SingleEnded(2);
      adc3 = ads.readADC_SingleEnded(3);

      volts0 = adc0 * gain;
      volts1 = adc1 * gain;

      float BVolts = volts1;
      float MVolts = volts0;
    
      Serial.println("-----------------------------------------------------------");
      //Serial.print("AIN0: "); Serial.print(adc0); Serial.print("  "); Serial.print(volts0); Serial.println("V");
      //Serial.print("AIN1: "); Serial.print(adc1); Serial.print("  "); Serial.print(volts1); Serial.println("V");
      //Serial.print("AIN2: "); Serial.print(adc2); Serial.print("  "); Serial.print(volts2); Serial.println("V");
      //Serial.print("AIN3: "); Serial.print(adc3); Serial.print("  "); Serial.print(volts3); Serial.println("V");

      Serial.print("BVolts: "); Serial.print(adc1); Serial.print("  "); Serial.print(BVolts); Serial.println("V");
      Serial.print("MVolts: "); Serial.print(adc0); Serial.print("  "); Serial.print(MVolts); Serial.println("V");


      poll++;
  }

  Serial.println(poll);



  


}