
/////////////////////////////////////////////////////

/*              ADS1115 Sensor Setup               */

/////////////////////////////////////////////////////

#include <Adafruit_ADS1X15.h>
Adafruit_ADS1115 ads;  /* Use this for the 16-bit version */
//const float gain = 0.0001875 // for Gain = 2/3x
const float gain = 0.000125; // for Gain = 1x
const float mapb = 4.907;

const int offsetSmoothing  = 60;
const int currentSmoothing = 3;
int       zeroingValue     = 0;

  // The ADC input range (or gain) can be changed via the following
  // functions, but be careful never to exceed VDD +0.3V max, or to
  // exceed the upper and lower limits if you adjust the input range!
  // Setting these values incorrectly may destroy your ADC!
  //                                                                ADS1015  ADS1115
  //                                                                -------  -------
  // ads.setGain(GAIN_TWOTHIRDS);  // 2/3x gain +/- 6.144V  1 bit = 3mV      0.1875mV (default)
  // ads.setGain(GAIN_ONE);        // 1x gain   +/- 4.096V  1 bit = 2mV      0.125mV
  //ads.setGain(GAIN_TWO);         // 2x gain   +/- 2.048V  1 bit = 1mV      0.0625mV
  // ads.setGain(GAIN_FOUR);       // 4x gain   +/- 1.024V  1 bit = 0.5mV    0.03125mV
  // ads.setGain(GAIN_EIGHT);      // 8x gain   +/- 0.512V  1 bit = 0.25mV   0.015625mV
  // ads.setGain(GAIN_SIXTEEN);    // 16x gain  +/- 0.256V  1 bit = 0.125mV  0.0078125mV

  // In theory with a gain set to one, the ads1115 would see 0.5 amp as a 101.89bit increment.
  // therefore we can set the mapb (milli amps per bit value) as 4.907 (500ma/101.89bit)

void setup()
{  
  Serial.begin(115200);
  

  Serial.println("Getting single-ended readings from AIN0..3");
  Serial.println("ADC Range: +/- 6.144V (1 bit = 3mV/ADS1015, 0.1875mV/ADS1115)");

  if (!ads.begin())
  {
    Serial.println("Failed to initialize ADS.");
    while (1);
  } 

  ads.setGain(GAIN_ONE);

  int adcAverage = 0;
  for (int i = 0; i<offsetSmoothing; i++)
  { 
    adcAverage = adcAverage + ads.readADC_SingleEnded(2);
  }
  
  zeroingValue = adcAverage/offsetSmoothing;
  

}


void loop()
{

  delay(500);


  int16_t adc0, adc1, adc2, adc3;
  float volts0, volts1, volts2, volts3;
  

  adc2 = ads.readADC_SingleEnded(2);

  adc2 -= zeroingValue;

  adc2 = constrain(adc2,0,30000);

  volts2 = adc2 * mapb;

  float CVolts = volts2 / 1000;

  Serial.println("-----------------------------------------------------------");

  Serial.print("Current: "); Serial.print(adc2); Serial.print("  "); Serial.print(CVolts); Serial.println("A");


}