#include <Wire.h>
#include <SPI.h>
#include <LoRa.h>

byte localAddress = 0xAA;
byte destinationAddress = 0xBB;

const int csPin = 8;
const int resetPin = 2;
const int irqPin = 7;

unsigned long lastSendTime = 0;
const int interval = 1000;
int count = 0;

float ampHours = 0;

void setup()
{
 
  Serial.begin(115200);           // start serial for output
  LoRa.setPins(csPin, resetPin, irqPin);
  
  if (!LoRa.begin(433E6)) {
    Serial.println("LoRa init failed. Check your connections.");
    //while (true) {}
  }
  Wire.begin(6);                // join i2c bus with address #4
  Wire.onReceive(receiveEvent); // register event
}

void loop()
{
  //Serial.println("Here");
  if (millis() >= lastSendTime + interval) {
    //String(toSend) = String("10");
    char toSend[5]; 
    dtostrf(ampHours,5,2,toSend);
    Serial.println(toSend);
    sendMessage(toSend);
    
    
//    Serial.print("Sending data ");
//    Serial.print(" from 0x" + String(localAddress, HEX));
//    Serial.println(" to 0x" + String(destinationAddress, HEX));

    lastSendTime += interval;
    
  }
}


void sendMessage(String outgoing) {
  LoRa.beginPacket();
  LoRa.write(destinationAddress);
  LoRa.write(localAddress);
  LoRa.write(outgoing.length());
  LoRa.print(outgoing);
  Serial.println("Lora Out: " + outgoing);
  LoRa.endPacket();
  Serial.println("Sent");
}
// function that executes whenever data is received from master
// this function is registered as an event, see setup()
void receiveEvent(int howMany)
{
  Serial.println("received i2c");
  String dataString = "";

  (void)howMany; // avoid compiler warning about unused parameter
  int charReceive = 0;
  while(Wire.available()){
    charReceive++;
    char c = Wire.read();
    dataString = dataString +c;
    Serial.print("Receiving Character:"); Serial.println(charReceive);
  }
  Serial.println("Got Data");
  ampHours = dataString.toFloat();
  
  //Serial.println(ampHours);

  

}
