#include <SPI.h>
#include <LoRa.h>

const int csPin = 10;
const int resetPin = 9;
const int irqPin = 2;

byte localAddress = 0xBB;
byte destinationAddress = 0xAA;


unsigned long lastPrintTime = 0;
const int interval = 1000;
int count = 0;

String incoming = "";
bool firstChar = true;

void setup() {
  Serial.begin(115200);
  delay(5000);
  Serial.println("Start LoRa duplex");

  LoRa.setPins(csPin, resetPin, irqPin);

  if (!LoRa.begin(433E6)) {
    Serial.println("LoRa init failed. Check your connections.");
  }
}

void loop() {
  receiveMessage(LoRa.parsePacket());

}



void receiveMessage(int packetSize) {

  char length = (char)LoRa.read();
  char address = (char)LoRa.read();
  char random = (char)LoRa.read();
  while (LoRa.available()) {

    if(firstChar == true){
      firstChar = false;
      incoming = "";
    }
    incoming += (char)LoRa.read();
    //Serial.println("Getting Data");  
  }
  firstChar = true;

  if (millis() >= lastPrintTime + interval) {
    lastPrintTime += interval;
    Serial.println(incoming);
  }

}
